<template>
  <div class="image-list-item">
    <a
      v-if="!managing"
      class="image-list-item"
      :href="large"
      :data-fancybox="groupName"
      :data-caption="image.caption"
      v-long-press="onLongPress"
    >
      <img
        :id="`image_${image.id}`"
        :data-image-id="image.id"
        :src="thumb"
        :alt="image.caption"
        :title="image.caption"
      />
    </a>
    <div
      v-if="managing"
      :class="{
        'image-list-item': true,
        'image-list-item--managing': !selected,
        'image-list-item--managing-selected': selected,
      }"
      @click="onClickWhenManaging"
    >
      <img
        :id="`image_${image.id}`"
        :data-image-id="image.id"
        :src="thumb"
        :alt="image.caption"
        :title="image.caption"
      />
      <div v-if="selected" class="image-list-item--position-badge">
        {{ position }}
      </div>
    </div>
  </div>
</template>

<script>
import { computed } from 'vue'
import { useStore } from 'vuex'
import { useApi } from '../../core'
import ImageHelper from '../lib/image-helper.js'

export default {
  name: 'ImageListItem',
  emits: ['imageLongPress', 'imageSelected', 'imageUnselected'],
  props: {
    image: { type: Object, required: true },
    groupName: { type: String, required: true },
    managing: { type: Boolean, required: true },
  },
  setup(props, context) {
    const store = useStore()
    const api = useApi()

    const thumb = computed(() => {
      return ImageHelper.getImageUrl(api.storageBaseUrl, props.image, 'thumb')
    })

    const large = computed(() => {
      return ImageHelper.getImageUrl(api.storageBaseUrl, props.image, 'large')
    })

    const authenticatedUserId = computed(() => {
      return store.state.identity.session.userId
    })

    const isCurrentUser = computed(() => {
      return authenticatedUserId.value > 0 && authenticatedUserId.value === props.image.userId
    })

    const showControls = computed(() => {
      return isCurrentUser.value
    })

    const position = computed(() => {
      return store.state.gallery.selectedImages.findIndex((x) => x.id === props.image.id) + 1
    })

    const selected = computed(() => {
      return position.value !== 0
    })

    const onLongPress = () => {
      context.emit('imageLongPress', props.image)
      context.emit('imageSelected', props.image)
    }

    const onClickWhenManaging = () => {
      if (selected.value) {
        context.emit('imageUnselected', props.image)
      } else {
        context.emit('imageSelected', props.image)
      }
    }

    return {
      thumb,
      large,
      authenticatedUserId,
      isCurrentUser,
      showControls,
      position,
      selected,
      onLongPress,
      onClickWhenManaging,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.image-list-item {
  float: left;
  width: vars.$galleryThumbWidth;
  height: vars.$galleryThumbWidth;
  margin-right: vars.$gallerySpacing;
  margin-bottom: vars.$gallerySpacing;
}

.image-list-item {
  img {
    width: vars.$galleryThumbWidth;
    height: vars.$galleryThumbWidth;
    background-color: vars.$panelColor;
  }
}

.image-list-item--managing {
  > img {
    box-sizing: content-box;
    border: vars.$managingBorderWidth solid vars.$panelColor;
    border-radius: vars.$managingBorderRadius;
    width: vars.$galleryThumbWidth - vars.$managingBorderWidth * 2;
    height: vars.$galleryThumbWidth - vars.$managingBorderWidth * 2;
    background-color: vars.$panelColor;
  }
}

.image-list-item--managing-selected {
  > img {
    box-sizing: content-box;
    border: vars.$managingSelectedBorderWidth solid vars.$linkColor;
    border-radius: vars.$managingBorderRadius;
    width: vars.$galleryThumbWidth - vars.$managingSelectedBorderWidth * 2;
    height: vars.$galleryThumbWidth - vars.$managingSelectedBorderWidth * 2;
  }
}

.image-list-item--position-badge {
  position: absolute;
  left: vars.$managingSelectedBorderWidth;
  top: vars.$managingSelectedBorderWidth;
  width: 2rem;
  height: 2rem;
  background-color: vars.$linkColor;
  border: 2px solid white;
  border-radius: 1rem;
  overflow: hidden;
  text-align: center;
  line-height: 1.75rem;
  color: white;
  font-weight: bold;
}

.dark {
  .image-list-item--managing img {
    border-color: vars.$darkPanelColor;
  }

  .image-list-item--managing-selected img {
    border-color: vars.$darkLinkColor;
  }

  .image-list-item--position-badge {
    background-color: vars.$darkLinkColor;
  }
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .image-list-item {
    position: relative;
    width: vars.$galleryThumbWidthLarge;
    height: vars.$galleryThumbWidthLarge;
    margin-right: vars.$gallerySpacingLarge;
    margin-bottom: vars.$gallerySpacingLarge;

    > img {
      width: vars.$galleryThumbWidthLarge;
      height: vars.$galleryThumbWidthLarge;
      background-color: vars.$panelColor;
    }
  }

  .image-list-item--managing {
    > img {
      width: vars.$galleryThumbWidthLarge - vars.$managingBorderWidth * 2;
      height: vars.$galleryThumbWidthLarge - vars.$managingBorderWidth * 2;
      background-color: vars.$darkPanelColor;
    }
  }

  .image-list-item--managing-selected {
    > img {
      width: vars.$galleryThumbWidthLarge - vars.$managingSelectedBorderWidth * 2;
      height: vars.$galleryThumbWidthLarge - vars.$managingSelectedBorderWidth * 2;
    }
  }
}
</style>
